.gba
.open "zm.gba","Arachnus.gba",0x8000000

.definelabel LockDoors,0x0300007B
.definelabel SpriteSlot0,0x30001AC
.definelabel CurrSpriteData,0x3000738
.definelabel SpriteRNG,0x300083C
.definelabel FrameCounter,0x3000C77
.definelabel SamusData,0x30013D4
.definelabel UnlockDoors,0x030054E4

.definelabel PlaySound,0x8002B20
.definelabel PlaySong,0x80039F4	
.definelabel SpawnSecondarySprite,0x800E258
.definelabel CheckClip,0x800F688
.definelabel CheckEndOfAnimation,0x800FBC8
.definelabel CheckAlmostEndOfAnimation,0x800FC00
.definelabel CheckEndOfAnimation2,0x800FC3C
.definelabel CheckAlmostEndOfAnimation2,0x800FC84
.definelabel CheckNearSprite,0x800FDE0
.definelabel SpriteDead,0x8011084
.definelabel CountNumberOfGivenSecondarySprite,0x8010738	
.definelabel SpawnDebris,0x8011E48
.definelabel ShakeScreen,0x8055378
.definelabel SetParticleEffect,0x80540EC
.definelabel EventFunctions,0x80608BC
.definelabel PrimarySpriteStats,0x82B0D68
.definelabel SecondarySpriteStats,0x82B1BE4
.definelabel SpriteAIPointers,0x875E8C0
.definelabel SSpriteAIPointers,0x875F1E8
.definelabel SpriteGfxPointers,0x875EBF8
.definelabel SpritePalPointers,0x875EEF0

.definelabel SpriteID,0x6C			;arachnus ID
.definelabel PartsID,0x28			;secondary body parts
.definelabel ShellID,0x35
.definelabel FireID,0x3A
.definelabel SwipeID,0x1E

.org 0x8760D40			;freespace
.include "Arachnus\MainAI.asm"
.include "Arachnus\BodyParts.asm"
.include "Arachnus\Projectiles.asm"
SpriteGfx:
.import "Arachnus\graphics.gfx.lz"
SpritePal:
.import "Arachnus\palette"
.include "Arachnus\Tables.asm"
.include "Arachnus\OAM.asm"

; primary sprite stats
.org PrimarySpriteStats + SpriteID * 0x12
    .halfword 0x32   ; health
    .halfword 0x1E   ; damage
    .halfword 0x1A    ; weakness
    .halfword 0      ; no drop
    .halfword 0x200  ; small health
    .halfword 0x200  ; large health
    .halfword 0      ; missile
    .halfword 0      ; super missile
    .halfword 0      ; power bomb

;secondary sprites
.org SecondarySpriteStats + PartsID * 0x12
    .halfword 0      ; health
    .halfword 0      ; damage
    .halfword 0      ; weakness
    .halfword 0		 ; no drop
    .halfword 0x100	     ; small health
    .halfword 0x100      ; large health
    .halfword 0x100      ; missile
    .halfword 0x80      ; super missile
    .halfword 0x80      ; power bomb

.org SecondarySpriteStats + ShellID * 0x12
    .halfword 1    		; health
    .halfword 0x20      ; damage
    .halfword 0         ; weakness
    .halfword 0         ; no drop
    .halfword 0x80	; small health
    .halfword 0x80      ; large health
    .halfword 0x200     ; missile
    .halfword 0x100     ; super missile
    .halfword 0      ; power bomb
	
.org SecondarySpriteStats + FireID * 0x12
    .halfword 0    		; health
    .halfword 0x0A      ; damage
    .halfword 0         ; weakness
    .halfword 0x400  ; no drop
    .halfword 0		 ; small health
    .halfword 0      ; large health
    .halfword 0      ; missile
    .halfword 0	     ; super missile
    .halfword 0      ; power bomb

.org SecondarySpriteStats + SwipeID * 0x12
    .halfword 0    		; health
    .halfword 0x18      ; damage
    .halfword 0         ; weakness
    .halfword 0x400  ; no drop
    .halfword 0		 ; small health
    .halfword 0      ; large health
    .halfword 0      ; missile
    .halfword 0	     ; super missile
    .halfword 0      ; power bomb
	
	
; AI pointer
.org SpriteAIPointers + SpriteID * 4
    .word MainAI + 1
	
;Body Parts AI pointer
.org SSpriteAIPointers + PartsID * 4
    .word BodyPartsMainAI + 1
	
;Shell AI pointer
.org SSpriteAIPointers + ShellID * 4
    .word ShellAI + 1
	
;projectile AI pointer
.org SSpriteAIPointers + FireID * 4
    .word FireballMainAI + 1
	
;projectile AI pointer
.org SSpriteAIPointers + SwipeID * 4
    .word SwipeMainAI + 1
	
; graphics pointer
.org SpriteGfxPointers + (SpriteID - 0x10) * 4
    .word SpriteGfx

; palette pointer
.org SpritePalPointers + (SpriteID - 0x10) * 4
    .word SpritePal


.close